#pragma once

#include <stdbool.h>

struct crypto_keys;

struct ap_envelope;
struct http_signature
{
	char* host;
	char* date;
	char* signature;
	char* digest;
	int content_length;
};

bool http_signature_make( const char* inbox, struct crypto_keys* keys, struct http_signature* sign, const char* postdata );
void http_signature_free( struct http_signature* sign );
bool http_signature_validate( struct ap_envelope* env, const char* request_target, const char* expected_actor );

