#pragma once

#include <stdbool.h>
#include <stddef.h>

struct crypto_keys;

struct crypto_keys* crypto_keys_new();
void crypto_keys_free( struct crypto_keys* keys );

bool crypto_keys_load_public ( struct crypto_keys* keys, const char* filename );
bool crypto_keys_load_private( struct crypto_keys* keys, const char* filename );

char* crypto_keys_sign( struct crypto_keys* keys, void* data, unsigned int size );
bool crypto_keys_verify( struct crypto_keys* keys, void* data, unsigned int size, char* signature );

char* base64_strict_encode( void* v_binary, size_t len );

