#pragma once

#include <stdbool.h>
#include <time.h>

struct outbox_envelope
{
	int id;
	int activity_id;
	int account_id;
	char* shared_inbox;
	bool sent;
	time_t retry_after;
	int retries;
};

struct outbox_envelope* outbox_envelope_new();
void outbox_envelope_free( struct outbox_envelope* env );

struct outbox_envelope* outbox_envelope_from_id( int id );

void outbox_envelope_save( struct outbox_envelope* env );
//struct outbox_envelope* outbox_envelope_load_next();
void outbox_envelope_delete( struct outbox_envelope* env );

struct outbox_envelope_list
{
	struct outbox_envelope** items;
	int count;
};

void outbox_envelope_list_save( struct outbox_envelope_list* oel );
void outbox_envelope_list_free_composite( struct outbox_envelope_list* oel );

